/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables.records;


import de.ship.db.enums.EnumElementnote;
import de.ship.db.tables.TCoreElementnote;

import java.time.LocalDateTime;

import org.jooq.Record1;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreElementnoteRecord extends UpdatableRecordImpl<TCoreElementnoteRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>common_dd.t_core_elementnote.lastchange</code>.
     */
    public void setLastchange(LocalDateTime value) {
        set(0, value);
    }

    /**
     * Getter for <code>common_dd.t_core_elementnote.lastchange</code>.
     */
    public LocalDateTime getLastchange() {
        return (LocalDateTime) get(0);
    }

    /**
     * Setter for <code>common_dd.t_core_elementnote.pk</code>. primary key
     */
    public void setPk(Integer value) {
        set(1, value);
    }

    /**
     * Getter for <code>common_dd.t_core_elementnote.pk</code>. primary key
     */
    public Integer getPk() {
        return (Integer) get(1);
    }

    /**
     * Setter for <code>common_dd.t_core_elementnote.fk_element</code>.
     * reference to hierarchy element
     */
    public void setFkElement(Integer value) {
        set(2, value);
    }

    /**
     * Getter for <code>common_dd.t_core_elementnote.fk_element</code>.
     * reference to hierarchy element
     */
    public Integer getFkElement() {
        return (Integer) get(2);
    }

    /**
     * Setter for <code>common_dd.t_core_elementnote.note_type</code>. the type
     * of this node
     */
    public void setNoteType(EnumElementnote value) {
        set(3, value);
    }

    /**
     * Getter for <code>common_dd.t_core_elementnote.note_type</code>. the type
     * of this node
     */
    public EnumElementnote getNoteType() {
        return (EnumElementnote) get(3);
    }

    /**
     * Setter for <code>common_dd.t_core_elementnote.fk_note_lang</code>.
     * reference to the translation of the note content
     */
    public void setFkNoteLang(String value) {
        set(4, value);
    }

    /**
     * Getter for <code>common_dd.t_core_elementnote.fk_note_lang</code>.
     * reference to the translation of the note content
     */
    public String getFkNoteLang() {
        return (String) get(4);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached TCoreElementnoteRecord
     */
    public TCoreElementnoteRecord() {
        super(TCoreElementnote.T_CORE_ELEMENTNOTE);
    }

    /**
     * Create a detached, initialised TCoreElementnoteRecord
     */
    public TCoreElementnoteRecord(LocalDateTime lastchange, Integer pk, Integer fkElement, EnumElementnote noteType, String fkNoteLang) {
        super(TCoreElementnote.T_CORE_ELEMENTNOTE);

        setLastchange(lastchange);
        setPk(pk);
        setFkElement(fkElement);
        setNoteType(noteType);
        setFkNoteLang(fkNoteLang);
        resetChangedOnNotNull();
    }
}
